;;assemble with :   $>  nasm -felf64 xtest.asm
;;Link with     :   $>  cc -s -o xtest -Wall -L/usr/X11R6/lib -lX11 xtest.o

BITS 64

%include "x_nasm.inc"
%include "xlib_nasm.inc"
%include "hll.inc"

%define XEvent_size 192  ;;;( 24 long ints) need to improve.

global main: 

section .bss

_INT scr
Colormap cmap
Window rootwin,win
_POINTER _dpy ;; pointer of _XDisplay struct
_POINTER gc   ;; pointer of _XGC  struct

_event resb XEvent_size        ;;need to improve

section .data 

hellocap db "hello",0
hellotext db "Hello World!!"
htextlen equ $-hellotext

section .text

main:

push   rbp
mov    rbp,rsp
sub    rsp,0x28

mov eax,_XDisplay_size
xor rdi,rdi
call XOpenDisplay
if rax,e,0
	;;;syswrite "Error in XOpenDisplay"	
	mov rax,-1
	add    rsp,0x28
	pop    rbx
	leave  
	ret
endif
mov [_dpy],rax

DefaultScreen _dpy
mov [scr],eax

RootWindow _dpy,scr
mov [rootwin],rax

DefaultColormap _dpy,scr
mov [cmap],rax

;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;win=XCreateSimpleWindow(dpy, rootwin, 0, 0, 200, 150, 0, BlackPixel(dpy, scr), WhitePixel(dpy, scr));

BlackPixel _dpy,scr
push rax
WhitePixel _dpy,scr
push rax
sub rsp,4         ;;
mov dword[rsp],0  ;; push dword 0  - 

mov rdi,[_dpy]
mov rsi,[rootwin]
mov rdx,0
mov rcx,0
mov r8,200
mov r9,150

call XCreateSimpleWindow
mov [win],rax

;;;;;;;;;;;;;;;;;
;;;XStoreName(dpy, win, "hello");

mov rdi,[_dpy]
mov rsi,[win]
mov rdx,hellocap
call XStoreName
;;;;;;;;;;;;;;;;
;;;;;;gc=XCreateGC(dpy, win, 0, NULL);

mov rdi,[_dpy]
mov rsi,[win]
mov rdx,0
mov rcx,0
call XCreateGC
mov [gc],rax
;;;;;;;;;;;;;;;;
;;;;XSetForeground(dpy, gc, WhitePixel(dpy, scr));

mov rdi,[_dpy]
mov rsi,[gc]
WhitePixel _dpy,scr
mov rdx,rax
call XSetForeground
;;;;;;;;;;;;;;;
;;;;	XSelectInput(dpy, win, ExposureMask|ButtonPressMask);

mov rdi,[_dpy]
mov rsi,[win]
mov rdx,ExposureMask|ButtonPressMask
call XSelectInput
;;;;;;;;;;;;;;;
;;;; XMapWindow(dpy, win);
mov rdi,[_dpy]
mov rsi,[win]
call XMapWindow
;;;;;;;;;;;;;
while rax,e,rax
	;;;;;;;;XNextEvent(dpy, &e);
	mov rdi,[_dpy]
	mov rsi,_event
	call XNextEvent
	movsx rbx,dword[_event]  ;;e.type
	mov rcx,[_event + XExposeEvent.count]
	ifand rbx,e,Expose,rcx,l,1
		;;;;XDrawString(dpy, win, gc, 30, 30, "Hello World!", 12);
		mov rdi,[_dpy]
		mov rsi,[win]
		mov rdx,[gc]
		mov rcx,30
		mov r8,30
		mov r9,hellotext
		mov dword[rsp],htextlen
		call XDrawString
	else
		if rbx,e,ButtonPress
			jmp JumpOutofWhile
		endif	
	endif
wend
JumpOutofWhile:


exitout:

add    rsp,0x28
leave  
ret

